package com.iden.bms.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.iden.common.entity.IdenWarningEveningComeSta;
import com.iden.common.service.IdenWarningEveningComeStaService;

import com.iden.common.vo.WarningEveningComeStaVO;
import com.iden.common.vo.PageReqVO;
import com.iden.common.vo.UserLogindConvertVO;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author makejava
 * @since 2021-05-21 00:08:38
 */
@Service
public class WarningEveningComeStaService {

    @Resource
    private IdenWarningEveningComeStaService idenWarningEveningComeStaService;

    

    /**
     * 查询昼伏夜出人员预警列表
     * @return
             */
    public IPage<WarningEveningComeStaVO> listWarningEveningComeSta(String district, String subdistrict,String communityName, String beginDate,String endDate,UserLogindConvertVO loginUser, PageReqVO pageReqVo) {
            IPage<IdenWarningEveningComeSta> page = new Page<>(pageReqVo.getCurrent(), pageReqVo.getPageSize());
            QueryWrapper<IdenWarningEveningComeSta> queryWrapper = new QueryWrapper<>();
            queryWrapper.lambda().like(StrUtil.isNotEmpty(communityName),IdenWarningEveningComeSta::getCommunityName,communityName)
                    .eq(StrUtil.isNotEmpty(district),IdenWarningEveningComeSta::getDistrict,district)
                    .eq(StrUtil.isNotEmpty(subdistrict),IdenWarningEveningComeSta::getSubdistrict,subdistrict)
                    .ge(StrUtil.isNotEmpty(beginDate),IdenWarningEveningComeSta::getDataDate,beginDate)
                    .le(StrUtil.isNotEmpty(endDate),IdenWarningEveningComeSta::getDataDate,endDate)
                    .orderByAsc(IdenWarningEveningComeSta::getId);

        queryWrapper.groupBy("community_id");
        queryWrapper.select(
                "community_id communityId",
                "max(community_code) communityCode",
                "max(community_name) communityName",
                "max(district) district",
                "max(subdistrict) subdistrict",
                "max(data_date) dataDate",
                "IFNULL(SUM(evening_come_count),0) eveningComeCount"
        );

            IPage<IdenWarningEveningComeSta> pageRes = this.idenWarningEveningComeStaService.page(page, queryWrapper);
            IPage<WarningEveningComeStaVO> results = new Page<>(pageRes.getCurrent(),pageRes.getSize(),pageRes.getTotal());
            if(CollUtil.isNotEmpty(pageRes.getRecords())){
                List<WarningEveningComeStaVO> list = new ArrayList<>();
                pageRes.getRecords().forEach(item -> {
                    WarningEveningComeStaVO resVO = new WarningEveningComeStaVO();
                    BeanUtils.copyProperties(item,resVO);
                    list.add(resVO);
                });
                results.setRecords(list);
            }
            return results;
    }


}