package com.iden.bms.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.iden.common.entity.IdenWarningKeynoteSta;
import com.iden.common.service.IdenWarningKeynoteStaService;
import com.iden.common.vo.PageReqVO;
import com.iden.common.vo.UserLogindConvertVO;
import com.iden.common.vo.WarningKeynoteStaVO;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author makejava
 * @since 2021-05-21 00:08:38
 */
@Service
public class WarningKeynoteStaService {

    @Resource
    private IdenWarningKeynoteStaService idenWarningKeynoteStaService;

    

    /**
     * 查询重点人员预警列表
     * @return
             */
    public IPage<WarningKeynoteStaVO> listWarningKeynoteSta(String district, String subdistrict,String communityName, String beginDate,String endDate,UserLogindConvertVO loginUser, PageReqVO pageReqVo) {
            IPage<IdenWarningKeynoteSta> page = new Page<>(pageReqVo.getCurrent(), pageReqVo.getPageSize());
            QueryWrapper<IdenWarningKeynoteSta> queryWrapper = new QueryWrapper<>();
            queryWrapper.lambda().like(StrUtil.isNotEmpty(communityName),IdenWarningKeynoteSta::getCommunityName,communityName)
                    .eq(StrUtil.isNotEmpty(district),IdenWarningKeynoteSta::getDistrict,district)
                    .eq(StrUtil.isNotEmpty(subdistrict),IdenWarningKeynoteSta::getSubdistrict,subdistrict)
                     .ge(StrUtil.isNotEmpty(beginDate),IdenWarningKeynoteSta::getDataDate,beginDate)
                     .le(StrUtil.isNotEmpty(endDate),IdenWarningKeynoteSta::getDataDate,endDate)
                    .orderByAsc(IdenWarningKeynoteSta::getId);

        queryWrapper.groupBy("community_id");
        queryWrapper.select(
                "community_id communityId",
                "max(community_code) communityCode",
                "max(community_name) communityName",
                "max(district) district",
                "max(subdistrict) subdistrict",
                "max(data_date) dataDate",
                "IFNULL(SUM(keynote_count),0) keynoteCount"
        );

            IPage<IdenWarningKeynoteSta> pageRes = this.idenWarningKeynoteStaService.page(page, queryWrapper);
            IPage<WarningKeynoteStaVO> results = new Page<>(pageRes.getCurrent(),pageRes.getSize(),pageRes.getTotal());
            if(CollUtil.isNotEmpty(pageRes.getRecords())){
                List<WarningKeynoteStaVO> list = new ArrayList<>();
                pageRes.getRecords().forEach(item -> {
                    WarningKeynoteStaVO resVO = new WarningKeynoteStaVO();
                    BeanUtils.copyProperties(item,resVO);
                    list.add(resVO);
                });
                results.setRecords(list);
            }
            return results;
    }


}