package com.iden.bms.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.iden.common.entity.IdenWarningPermanentSta;
import com.iden.common.service.IdenWarningPermanentStaService;
import com.iden.common.vo.PageReqVO;
import com.iden.common.vo.UserLogindConvertVO;
import com.iden.common.vo.WarningPermanentStaVO;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author makejava
 * @since 2021-05-21 00:08:38
 */
@Service
public class WarningPermanentStaService {

    @Resource
    private IdenWarningPermanentStaService idenWarningPermanentStaService;

    

    /**
     * 查询常住人员预警列表
     * @return
             */
    public IPage<WarningPermanentStaVO> listWarningPermanentSta(String district, String subdistrict,String communityName, String beginDate,String endDate,UserLogindConvertVO loginUser, PageReqVO pageReqVo) {
            IPage<IdenWarningPermanentSta> page = new Page<>(pageReqVo.getCurrent(), pageReqVo.getPageSize());
            QueryWrapper<IdenWarningPermanentSta> queryWrapper = new QueryWrapper<>();
            queryWrapper.lambda().like(StrUtil.isNotEmpty(communityName),IdenWarningPermanentSta::getCommunityName,communityName)
                    .eq(StrUtil.isNotEmpty(district),IdenWarningPermanentSta::getDistrict,district)
                    .eq(StrUtil.isNotEmpty(subdistrict),IdenWarningPermanentSta::getSubdistrict,subdistrict)
                    .ge(StrUtil.isNotEmpty(beginDate),IdenWarningPermanentSta::getDataDate,beginDate)
                    .le(StrUtil.isNotEmpty(endDate),IdenWarningPermanentSta::getDataDate,endDate)
                    .orderByAsc(IdenWarningPermanentSta::getId);

        queryWrapper.groupBy("community_id");
        queryWrapper.select(
                "community_id communityId",
                "max(community_code) communityCode",
                "max(community_name) communityName",
                "max(district) district",
                "max(subdistrict) subdistrict",
                "max(data_date) dataDate",
                "IFNULL(SUM(permanent_count),0) permanentCount"
        );

            IPage<IdenWarningPermanentSta> pageRes = this.idenWarningPermanentStaService.page(page, queryWrapper);
            IPage<WarningPermanentStaVO> results = new Page<>(pageRes.getCurrent(),pageRes.getSize(),pageRes.getTotal());
            if(CollUtil.isNotEmpty(pageRes.getRecords())){
                List<WarningPermanentStaVO> list = new ArrayList<>();
                pageRes.getRecords().forEach(item -> {
                    WarningPermanentStaVO resVO = new WarningPermanentStaVO();
                    BeanUtils.copyProperties(item,resVO);
                    list.add(resVO);
                });
                results.setRecords(list);
            }
            return results;
    }


}