package com.iden.bms.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.iden.common.entity.IdenWarningStrangerSta;
import com.iden.common.service.IdenWarningStrangerStaService;
import com.iden.common.vo.PageReqVO;
import com.iden.common.vo.UserLogindConvertVO;
import com.iden.common.vo.WarningStrangerStaVO;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author makejava
 * @since 2021-05-21 00:08:38
 */
@Service
public class WarningStrangerStaService {

    @Resource
    private IdenWarningStrangerStaService idenWarningStrangerStaService;

    

    /**
     * 查询陌生人员预警列表
     * @return
             */
    public IPage<WarningStrangerStaVO> listWarningStrangerSta(String district, String subdistrict,String communityName, String beginDate,String endDate,UserLogindConvertVO loginUser, PageReqVO pageReqVo) {
            IPage<IdenWarningStrangerSta> page = new Page<>(pageReqVo.getCurrent(), pageReqVo.getPageSize());
            QueryWrapper<IdenWarningStrangerSta> queryWrapper = new QueryWrapper<>();
            queryWrapper.lambda().like(StrUtil.isNotEmpty(communityName),IdenWarningStrangerSta::getCommunityName,communityName)
                    .eq(StrUtil.isNotEmpty(district),IdenWarningStrangerSta::getDistrict,district)
                    .eq(StrUtil.isNotEmpty(subdistrict),IdenWarningStrangerSta::getSubdistrict,subdistrict)
                    .ge(StrUtil.isNotEmpty(beginDate),IdenWarningStrangerSta::getDataDate,beginDate)
                    .le(StrUtil.isNotEmpty(endDate),IdenWarningStrangerSta::getDataDate,endDate)
                    .orderByAsc(IdenWarningStrangerSta::getId);

        queryWrapper.groupBy("community_id");
        queryWrapper.select(
                "community_id communityId",
                "max(community_code) communityCode",
                "max(community_name) communityName",
                "max(district) district",
                "max(subdistrict) subdistrict",
                "max(data_date) dataDate",
                "IFNULL(SUM(stranger_count),0) strangerCount"
        );

            IPage<IdenWarningStrangerSta> pageRes = this.idenWarningStrangerStaService.page(page, queryWrapper);
            IPage<WarningStrangerStaVO> results = new Page<>(pageRes.getCurrent(),pageRes.getSize(),pageRes.getTotal());
            if(CollUtil.isNotEmpty(pageRes.getRecords())){
                List<WarningStrangerStaVO> list = new ArrayList<>();
                pageRes.getRecords().forEach(item -> {
                    WarningStrangerStaVO resVO = new WarningStrangerStaVO();
                    BeanUtils.copyProperties(item,resVO);
                    list.add(resVO);
                });
                results.setRecords(list);
            }
            return results;
    }


}