package com.iden.common.enums;


import cn.hutool.core.util.StrUtil;

/**
 * @Author:java
 * @Date: 2021/05/27
 */
public enum PersonTypeEnum {
    /**
     * 人员类型
     */
    STRANGER("0","陌生人员"),
    KEYNOTE("1","重点人员"),
    COMMUNITY("2","小区人员");
    private String value;
    private String name;
    PersonTypeEnum(String value, String name) {
        this.value = value;
        this.name = name;
    }
    public String getValue() {
        return value;
    }

    public static String getValueToName(String code){
        if (StrUtil.isEmpty(code)){
            return null;
        }

        String names = "";
        String[] types = code.split(",");
        if(types.length > 0){
            for(String type : types){
                if (STRANGER.getValue().equals(type)){
                    names += STRANGER.name + ",";
                } else if (KEYNOTE.getValue().equals(type)){
                    names += KEYNOTE.name + ",";
                } else if (COMMUNITY.getValue().equals(type)){
                    names += COMMUNITY.name + ",";
                }
            }
        }
        if(names.endsWith(",")) {
            names = names.substring(0,names.length() - 1);
        }
      return names;

    }
}
